'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.abastractSelectionScheme = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _area = require('../utils/area');

require('../styles/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AbstractSelection = function (_Component) {
  _inherits(AbstractSelection, _Component);

  function AbstractSelection(props) {
    _classCallCheck(this, AbstractSelection);

    var _this = _possibleConstructorReturn(this, (AbstractSelection.__proto__ || Object.getPrototypeOf(AbstractSelection)).call(this, props));

    _this.state = {
      isFocused: false,
      isHovered: false,
      area: props.area
    };

    _this.getPositionStyles = _this.getPositionStyles.bind(_this);
    _this.handleMouseOver = _this.handleMouseOver.bind(_this);
    _this.handleMouseOut = _this.handleMouseOut.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.setState = _this.setState.bind(_this);

    _this.className = 'mr-selection';
    return _this;
  }

  _createClass(AbstractSelection, [{
    key: 'getStyles',
    value: function getStyles() {
      return this.getPositionStyles();
    }
  }, {
    key: 'getMaxPossibleArea',
    value: function getMaxPossibleArea() {
      var containerParameters = this.props.containerParameters;

      return (0, _area.calculateArea)(containerParameters.dimensions);
    }
  }, {
    key: 'getPositionStyles',
    value: function getPositionStyles() {
      var _state$area = this.state.area,
          dimensions = _state$area.dimensions,
          coordinates = _state$area.coordinates;

      var area = (0, _area.calculateArea)(dimensions);
      var maxPossibleArea = this.getMaxPossibleArea();
      var zIndex = maxPossibleArea - area;

      return Object.freeze({
        width: dimensions.width + 'px',
        height: dimensions.height + 'px',
        left: coordinates.x + 'px',
        top: coordinates.y + 'px',
        zIndex: zIndex
      });
    }
  }, {
    key: 'getClassName',
    value: function getClassName() {
      return this.className;
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus() {
      this.setState({ isFocused: true });

      if (this.props.onFocus) {
        this.props.onFocus(this.selectionEl);
      }
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      this.setState({ isFocused: false });

      if (this.props.onBlur) {
        this.props.onBlur();
      }
    }
  }, {
    key: 'handleMouseOver',
    value: function handleMouseOver() {
      this.setState({ isHovered: true });
    }
  }, {
    key: 'handleMouseOut',
    value: function handleMouseOut() {
      this.setState({ isHovered: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var styles = this.getStyles();
      var className = this.getClassName();

      var _props$focusable = this.props.focusable,
          focusable = _props$focusable === undefined ? true : _props$focusable;


      return _react2.default.createElement('div', {
        tabIndex: +focusable - 1,
        role: 'button',
        ref: function ref(el) {
          return _this2.selectionEl = el;
        },
        className: className,
        style: styles,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut,
        onClick: this.props.onClick
      });
    }
  }]);

  return AbstractSelection;
}(_react.Component);

AbstractSelection.propTypes = {
  area: _propTypes2.default.shape({
    dimensions: _propTypes2.default.shape({
      width: _propTypes2.default.number,
      height: _propTypes2.default.number
    }),
    coordinates: _propTypes2.default.shape({
      x: _propTypes2.default.number,
      y: _propTypes2.default.number
    })
  }).isRequired,
  zIndex: _propTypes2.default.number.isRequired,
  focusable: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func
};

AbstractSelection.defaultProps = {
  onClick: null,
  onFocus: null,
  onBlur: null,
  focusable: true
};

var abastractSelectionScheme = exports.abastractSelectionScheme = AbstractSelection.propTypes;

exports.default = AbstractSelection;