'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectionContext = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cssClassCombiner = require('css-class-combiner');

var _cssClassCombiner2 = _interopRequireDefault(_cssClassCombiner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectionContext = exports.SelectionContext = _react2.default.createContext('selection_container');

var SelectionContainer = function (_Component) {
  _inherits(SelectionContainer, _Component);

  function SelectionContainer(props) {
    _classCallCheck(this, SelectionContainer);

    var _this = _possibleConstructorReturn(this, (SelectionContainer.__proto__ || Object.getPrototypeOf(SelectionContainer)).call(this, props));

    _this.state = {
      rootParameters: props.containerParameters
    };

    _this.setRootParameters = _this.setRootParameters.bind(_this);
    return _this;
  }

  _createClass(SelectionContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.setRootParameters);
      this.setRootParameters();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.containerParameters !== this.props.containerParameters) {
        this.setState({ rootParameters: nextProps.containerParameters });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.setRootParameters);
    }
  }, {
    key: 'setRootParameters',
    value: function setRootParameters() {
      var _root$getBoundingClie = this.root.getBoundingClientRect(),
          left = _root$getBoundingClie.left,
          top = _root$getBoundingClie.top;

      top += window.pageYOffset;
      left += window.pageXOffset;

      var height = this.root.clientHeight;
      var width = this.root.clientWidth;

      var rootParameters = {
        offsets: {
          left: left, top: top
        },
        dimensions: {
          width: width, height: height
        }
      };

      this.setState({ rootParameters: rootParameters });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var rootParameters = this.state.rootParameters;

      var style = {};

      var hasZeroDimension = Object.values(rootParameters.dimensions).some(function (val) {
        return val === 0;
      });

      if (!hasZeroDimension) {
        style = {
          width: rootParameters.dimensions.width + 'px',
          height: rootParameters.dimensions.height + 'px'
        };
      }

      var className = new _cssClassCombiner2.default('mr-selection-container').combine(this.props.className);

      return _react2.default.createElement(
        SelectionContext.Provider,
        {
          value: { containerParameters: rootParameters }
        },
        _react2.default.createElement(
          'div',
          {
            ref: function ref(el) {
              return _this2.root = el;
            },
            className: className,
            style: style
          },
          this.props.children
        )
      );
    }
  }]);

  return SelectionContainer;
}(_react.Component);

SelectionContainer.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]).isRequired,
  className: _propTypes2.default.string,
  containerParameters: _propTypes2.default.object
};

SelectionContainer.defaultProps = {
  className: '',
  containerParameters: {
    dimensions: {
      width: 0,
      height: 0
    },
    offsets: {
      left: 0,
      top: 0
    }
  }
};

exports.default = SelectionContainer;