'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cssClassCombiner = require('css-class-combiner');

var _cssClassCombiner2 = _interopRequireDefault(_cssClassCombiner);

var _AbstractSelection2 = require('./AbstractSelection');

var _AbstractSelection3 = _interopRequireDefault(_AbstractSelection2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StyledSelection = function (_AbstractSelection) {
  _inherits(StyledSelection, _AbstractSelection);

  function StyledSelection() {
    _classCallCheck(this, StyledSelection);

    return _possibleConstructorReturn(this, (StyledSelection.__proto__ || Object.getPrototypeOf(StyledSelection)).apply(this, arguments));
  }

  _createClass(StyledSelection, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ area: nextProps.area });
    }
  }, {
    key: 'getClassName',
    value: function getClassName() {
      var _state = this.state,
          isHovered = _state.isHovered,
          isFocused = _state.isFocused;
      var _props = this.props,
          className = _props.className,
          hoverClassName = _props.hoverClassName,
          focusClassName = _props.focusClassName;


      return new _cssClassCombiner2.default('mr-selection').combine(className).combineIf(isHovered, hoverClassName).combineIf(isFocused, focusClassName);
    }
  }, {
    key: 'getStyles',
    value: function getStyles() {
      return _extends({}, this.props.style, this.getPositionStyles());
    }
  }]);

  return StyledSelection;
}(_AbstractSelection3.default);

StyledSelection.propTypes = {
  hoverClassName: _propTypes2.default.string,
  focusClassName: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object
};

StyledSelection.defaultProps = {
  hoverClassName: '',
  focusClassName: '',
  className: '',
  style: {}
};

exports.default = StyledSelection;